<template>
  <v-layout align-start wrap class="writing-activity-wrapper">
    <header class="layout wrap">
      <v-flex xs12 v-if="$vuetify.breakpoint.mdAndDown">
        <writing-tabs :activeTab="activeTab" @setTab="setTab"/>
      </v-flex>
      <v-flex xs12>
        <writing-header :lifes="progress.remainingLives" @exit="exit" :title="stationName"/>
      </v-flex>
      <v-flex xs12 v-if="$vuetify.breakpoint.mdAndDown">
        <writing-title :title="activity.description.text"/>
      </v-flex>
    </header>
    <v-layout justify-center align-start class="writing-activity-wrapper__container">
      <v-container fill-height class="pt-0" v-if="isDesktop">
        <writing-desktop
          :concluded="progress.concluded"
          :activeTab="activeTab"
          :activity="activity"
          :feedback="feedback"
          :text="text"
          @input="setText"
        />
      </v-container>
      <writing-mobile
        v-if="!isDesktop"
        :concluded="progress.concluded"
        :activeTab="activeTab"
        :activity="activity"
        :feedback="feedback"
        :text="text"
        @input="setText"
        :slideName="slideName"
      />
    </v-layout>
    <writing-footer
      v-if="activeTab || isDesktop"
      :lifes="progress.remainingLives"
      :step="progress.step"
      :concluded="progress.concluded"
      :disabled-check="disabledCheck"
      :tooltip="tooltip"
      @help="help"
      @check="check"
      :hiddenCheck="hiddenCheck"
    />
  </v-layout>
</template>
<script>
import WritingTabs from '../../Globals/Tabs/Index';
import WritingHeader from './Header/WritingHeader';
import WritingFooter from './Footer/Index';
import Activity from '../../../Entity/Activity/Activity';
import WritingDesktop from '../Desktop/Index';
import WritingMobile from '../Mobile/Index';
import WritingTitle from './Title/Index';
import Feedback from '../../../Entity/Feedback/Feedback';
import Progress from '../../../Entity/Activity/Progress';

export default {
  components: {
    WritingTabs,
    WritingDesktop,
    WritingMobile,
    WritingHeader,
    WritingFooter,
    WritingTitle,
  },
  props: {
    activeTab: {
      type: Number,
      default: 0,
    },
    stationName: {
      type: String,
      default: () => '',
    },
    slideName: {
      type: String,
      default: () => 'slide-left',
    },
    loading: {
      type: Boolean,
      default: false,
    },
    text: {
      type: String,
      default: () => '',
    },
    activity: {
      type: Object,
      default: () => new Activity(),
    },
    progress: {
      type: Object,
      default: () => new Progress(),
    },
    feedback: {
      type: Object,
      default: () => new Feedback(),
    },
  },

  methods: {
    setTab(tab) {
      this.$emit('setTab', tab);
    },
    exit() {
      this.$emit('exit');
    },
    help() {
      this.$emit('help');
    },
    check() {
      this.$emit('check', this.text);
    },
    setText(text) {
      this.$emit('update:text', text);
    },
  },
  computed: {
    hiddenCheck() {
      return !this.$vuetify.breakpoint.lgAndUp && this.activeTab === 0;
    },
    tooltip() {
      return this.activity.getTooltip(this.text);
    },
    disabledCheck() {
      return (
        Activity.getNumberOfWords(this.text) < this.activity.minWords
        || this.loading
        || this.text.length > 5000
      );
    },
    isDesktop() {
      return this.$vuetify.breakpoint.lgAndUp;
    },
  },
  mounted() {
    this.setText(this.feedback.sentence);
  },
};
</script>
<style lang="sass" scoped>
  @import ~@/styles/defaults/mobileFirst
  .writing-activity-wrapper
    width: 100%
    &__container
      position: relative
      width: 100%
      overflow: auto
    +media-min-lg()
      position: relative
      z-index: 10
      height: auto
      &__container
        padding: 10px 0px
        height: auto
</style>
